# ****************************************************************************
# 
# Copyright 2009 Sandia Corporation. Under the terms of Contract
# DE-AC04-94AL85000 with Sandia Corporation, the U.S. Government
# retains certain rights in this software.
# 
# BSD Open Source License.
# All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# 
#    * Redistributions of source code must retain the above copyright notice,
#      this list of conditions and the following disclaimer.
#    * Redistributions in binary form must reproduce the above copyright
#      notice, this list of conditions and the following disclaimer in the
#      documentation and/or other materials provided with the distribution.
#    * Neither the name of Sandia National Laboratories nor the names of its
#      contributors may be used to endorse or promote products derived from
#      this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.
#
# ****************************************************************************

#
#To change between building 64 and 32 bit binaries, specify on the command line a value for ARCH.
#Can be either "32bit" or "64bit".  Default is 64bit.  Example: "make ARCH=32bit"
#

ifeq ($(ARCH),32bit)
MACHINE=-m32
else
MACHINE=-m64
endif

# Determine OS
OS := $(shell uname -s)

INCLUDE=-Iinclude -I../SLBM/include -I../GeoTessCPP/include

LIB=-L../lib -lslbm -lgeotesscpp

ifeq ($(OS),SunOS)  
	COMPILE = CC -D$(OS) $(MACHINE) -Kpic -xO5 -dalign -fns -fsimple=2 -ftrap=%none ${INCLUDE} -c
	LINK = CC -D$(OS) $(MACHINE) -o ../bin/slbmtestcc main.o ${LIB} -lm -lCrun -lCstd
	VERSION = CC -V
endif
ifeq ($(OS),Linux)
	COMPILE = gcc -D$(OS) $(MACHINE) -fPIC -O3 -ffast-math -fno-trapping-math ${INCLUDE} -c
	LINK = gcc -D$(OS) $(MACHINE) -o ../bin/slbmtestcc main.o ${LIB} -lm -lstdc++
	VERSION = gcc --version
endif
ifeq ($(OS),Darwin)
	COMPILE = gcc -D$(OS) $(MACHINE) -O3 ${INCLUDE} -c
	LINK = gcc -D$(OS) $(MACHINE) -o ../bin/slbmtestcc main.o ${LIB} -lm -lstdc++
	VERSION = gcc --version
endif

#-------------------------------------------------------------------------------
# targets
#-------------------------------------------------------------------------------

all : info clean main.o link clean_objs done

main.o : 
	@echo "Compile src/main.cc"
	${COMPILE} src/main.cc
	@echo


link : 
	@echo "link executable main"
	${LINK}
	@echo

clean_objs :
	rm -f main.o

clean :
	rm -f ../bin/slbmtestcc
	rm -f main.o
	@echo

info :
	@ echo "========================================="
	@ echo "Building SLBM_test_cc on $(OS)" 
	@ $(VERSION)
	@echo

done :
	@echo "Done building SLBM_test_cc"
	@echo

